#include <boost/math/special_functions/gamma.hpp>
#include <boost/math/special_functions/next.hpp>
#include <boost/math/tr1.hpp>
#include <iostream>
#include <quadmath.h>
#include <math.h>

extern "C" long double ld_lgamma(long double); 
long double ld_lgamma(long double x) {
  return boost::math::lgamma(x);
}

extern "C" float f_lgamma(float); 
float f_lgamma(float x) {
  return (float) ld_lgamma(x);  
}

extern "C" double d_lgamma(double); 
double d_lgamma(double x) {
  return (double) ld_lgamma(x);  
}

extern "C" __float128 Ld_lgamma(__float128); 
__float128 Ld_lgamma(__float128 x) {
  long double xld = x;
  return (__float128) ld_lgamma(xld);
}

void test() {
  // __float128 x = M_PI_2q;
  __float128 y = 0.0Q;
  
  long double xL = M_PIl;
  long double yL = boost::math::lgamma(xL);;
  
  char fbuf[128];

  y = yL;
  
  quadmath_snprintf (fbuf, sizeof(fbuf), "%+-#*.30Qf", 42, y);
  std::cout << fbuf << "\n";
  
  snprintf (fbuf, sizeof(fbuf), "%+-#*.30Lf", 42, yL);
  std::cout << fbuf << "\n";
}
